<template>
  <div class='admin-wrap'>
    <div class='admin container example'>
      <div class='admin__editor'>
        <div class='admin__header'>
          <base-input :id="'articleName'" v-model='article[currentLanguage].articleTitle' :label="'Загаловок'" class='article-name' placeholder='Название статьи' />
          <admin-dropdown
            :id="'language'"
            class='article-language'
            :label="'Язык статьи'"
            :list="languages"
            item-key="language"
            :default-value="languages[0]"
            @selected="(value) => selectLanguage(value)" />
        </div>
        <client-only>
          <quill-editor
            ref='textEditor'
            v-model='article[currentLanguage].content'
            :options='editorOption'
          ></quill-editor>
        </client-only>
        <base-checkbox v-model='article[currentLanguage].publish' class='publish-checkbox' name='publish' :value='true' :label="'Опубликовать'" />
        <admin-button @click.native='saveArticle' class='save-btn'>
          Сохранить
        </admin-button>
        <div v-show='successfulAdd' class='successful-add'>
          <p>Статья сохранена</p>
        </div>
      </div>
      <div class='admin__sidebar'>
        <admin-dropdown
          :id="'category'"
          :label="'Категория'"
          :list="formatedCategor"
          item-key="category"
          :default-value="formatedCategor[currentCategory]"
          @selected="(value) => setCategory(value)" />
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import BaseCheckbox from '../../../components/base/BaseCheckbox'
import BaseInput from '../../../components/base/BaseInput'
import AdminDropdown from '../../../components/admin/AdminDropdown'
import AdminButton from '../../../components/admin/AdminButton'
export default {
  components: { AdminButton, AdminDropdown, BaseInput, BaseCheckbox },
  layout: 'admin',
  async asyncData({ store, params }) {
    const article = await store.getters['admin/getArticles'].find(article => article.id === params.id)
    return { article }
  },
  data () {
    return {
      languages: [ { language: 'En', id: 1, value: 'en' }, { language: 'Ch', id: 2, value: 'ch' }, { language: 'Tur', id: 3, value: 'tur' }, { language: 'Ru', id: 4, value: 'ru' }],
      currentLanguage: 'en',
      successfulAdd: false,
      article: {
        category: '',
        en: {content: '', publish: '', articleTitle: ''},
        ch: {content: '', publish: '', articleTitle: ''},
        tur: {content: '', publish: '', articleTitle: ''},
        ru: {content: '', publish: '', articleTitle: ''},
      },
      editorOption: {
        placeholder: 'Статья',
        theme: 'snow',
        modules: {
          toolbar: [
            ['bold', 'italic', 'underline', 'strike'],
            ['blockquote', 'code-block'],
            [{ 'header': 1 }, { 'header': 2 }],
            [{ 'list': 'ordered' }, { 'list': 'bullet' }],
            [{ 'script': 'sub' }, { 'script': 'super' }],
            [{ 'indent': '-1' }, { 'indent': '+1' }],
            [{ 'direction': 'rtl' }],
            [{ 'size': ['small', false, 'large', 'huge'] }],
            [{ 'header': [1, 2, 3, 4, 5, 6, false] }],
            [{ 'font': [] }],
            [{ 'color': [] }, { 'background': [] }],
            [{ 'align': [] }],
            ['clean'],
            ['link', 'image', 'video']

          ],
          imageResize: {
            displaySize: true
          },
          imageDrop: true
        }
      }
    }
  },

  computed: {
    ...mapGetters({
      getCategory: "admin/getCategory"
    }),

    formatedCategor() {
      return this.getCategory.map(( item, index ) => {
        return {
          category: item.name,
          id: index,
          value: item.name
        }
      })
    },

    currentCategory() {
      return this.formatedCategor.findIndex(item => item.category === this.article.category)
    }
  },

  methods: {
    ...mapActions({
      setArticle: "admin/setArticle"
    }),

    saveArticle() {
      if(this.article.category.length && this.article[this.currentLanguage].articleTitle.length) {
        this.successfulAdd = true
        setTimeout(() => {this.successfulAdd = false}, 3000)
      }
    },

    selectLanguage(value) {
      this.currentLanguage = value.value
    },

    setCategory(value) {
      this.article.id = `${Math.random()}`.split(".")[1]
      this.article.category = value.value
    }
  }
}
</script>

<style lang='scss' scoped>
.admin-wrap {
  min-height: 100vh;
}

.admin {
  padding-top: 60px;
  padding-bottom: 40px;
  display: flex;

  &__header {
    display: flex;
    justify-content: space-between;
  }

  &__editor {
    width: calc(100% - 200px);
    padding-right: 20px;
    padding-top: 5px;
  }

  &__sidebar {
    width: 200px;
    padding: 5px 20px 10px;
    border-left: 1px solid #66B6FF;

    p {
      margin: 0;
    }
  }
}

.save-btn {
  margin-top: 30px;
}

.article-name {
  width: 400px;
  margin-bottom: 30px;
}

.publish-checkbox {
  margin-top: 30px;
}


.successful-add {
  margin-top: 40px;
  background: rgba(22,186,82,.05);
  border-radius: 4px;
  border: 1px solid #16ba52;
  padding: 10px 20px;

  p {
    line-height: 14px;
    color: #777;
  }
}
</style>
